# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`netplan`](#netplan): Install Netplan
* [`netplan::install`](#netplan--install): Install Netplan package

### Defined types

* [`netplan::interface`](#netplan--interface): Create interface $dev
* [`netplan::route`](#netplan--route): Create route for $dev interface

### Functions

* [`core_netplan::get::type`](#core_netplan--get--type): See https://puppet.com/docs/puppet/latest/lang_write_functions_in_puppet.html for more information on native puppet functions.

## Classes

### <a name="netplan"></a>`netplan`

Install Netplan

#### Examples

##### 

```puppet
include netplan
```

#### Parameters

The following parameters are available in the `netplan` class:

* [`package_name`](#-netplan--package_name)
* [`package_ensure`](#-netplan--package_ensure)
* [`config_file`](#-netplan--config_file)
* [`replace`](#-netplan--replace)
* [`config_version`](#-netplan--config_version)
* [`config_hash`](#-netplan--config_hash)

##### <a name="-netplan--package_name"></a>`package_name`

Data type: `String`



Default value: `'netplan'`

##### <a name="-netplan--package_ensure"></a>`package_ensure`

Data type: `String`



Default value: `'present'`

##### <a name="-netplan--config_file"></a>`config_file`

Data type: `String`



Default value: `'/etc/netplan/netplan.yaml'`

##### <a name="-netplan--replace"></a>`replace`

Data type: `Boolean`



Default value: `true`

##### <a name="-netplan--config_version"></a>`config_version`

Data type: `Integer`



Default value: `2`

##### <a name="-netplan--config_hash"></a>`config_hash`

Data type: `Hash`



Default value:

```puppet
{
    'network' => {
      'version'  => $config_version,
      'renderer' => 'networkd'
    }
  }
```

### <a name="netplan--install"></a>`netplan::install`

Install Netplan package

#### Examples

##### 

```puppet
include netplan::install
```

## Defined types

### <a name="netplan--interface"></a>`netplan::interface`

Create interface $dev

#### Examples

##### 

```puppet
netplan::interface { 'ens3': addresses => ['192.168.0.1'] }
```

#### Parameters

The following parameters are available in the `netplan::interface` defined type:

* [`type`](#-netplan--interface--type)
* [`dev`](#-netplan--interface--dev)
* [`addresses`](#-netplan--interface--addresses)
* [`flush`](#-netplan--interface--flush)
* [`opts`](#-netplan--interface--opts)

##### <a name="-netplan--interface--type"></a>`type`

Data type: `String`

Type of device

Default value: `'ethernets'`

##### <a name="-netplan--interface--dev"></a>`dev`

Data type: `String`

Device name

Default value: `$name`

##### <a name="-netplan--interface--addresses"></a>`addresses`

Data type: `Array`



Default value: `[]`

##### <a name="-netplan--interface--flush"></a>`flush`

Data type: `Boolean`

Deletes all addresses on the interface before applying the new configuration

Default value: `false`

##### <a name="-netplan--interface--opts"></a>`opts`

Data type: `Hash`



Default value: `{}`

### <a name="netplan--route"></a>`netplan::route`

Create route for $dev interface

#### Examples

##### 

```puppet
netplan::route { 'Added new route for Office net': dev => 'ens3', to => '172.10.0.1', via => '192.168.0.1' }
```

#### Parameters

The following parameters are available in the `netplan::route` defined type:

* [`dev`](#-netplan--route--dev)
* [`to`](#-netplan--route--to)
* [`via`](#-netplan--route--via)
* [`type`](#-netplan--route--type)
* [`opts`](#-netplan--route--opts)

##### <a name="-netplan--route--dev"></a>`dev`

Data type: `String`



##### <a name="-netplan--route--to"></a>`to`

Data type: `String`



##### <a name="-netplan--route--via"></a>`via`

Data type: `String`



##### <a name="-netplan--route--type"></a>`type`

Data type: `String`



Default value: `'ethernets'`

##### <a name="-netplan--route--opts"></a>`opts`

Data type: `Hash`



Default value: `{}`

## Functions

### <a name="core_netplan--get--type"></a>`core_netplan::get::type`

Type: Puppet Language

See https://puppet.com/docs/puppet/latest/lang_write_functions_in_puppet.html
for more information on native puppet functions.

#### `core_netplan::get::type(String $type)`

See https://puppet.com/docs/puppet/latest/lang_write_functions_in_puppet.html
for more information on native puppet functions.

Returns: `String` String

##### `type`

Data type: `String`



